#include "picture.h"

Picture::Picture(string device) throw (mimasexception) {

  try {

    image_v4linput< pixel_rgba > imageInput(device);
    imageInput >> img;

  } catch (exception &e) {

    mimasexception _e;
    _e << "Unable to read device";
    throw _e;

  }

}

Picture::Picture(image< pixel_rgba > &image) {

  img = image;

}

Picture::Picture(image< unsigned char > &image) {

  img = image;

}

// convert from image to QPixmap
QPixmap Picture::img2pixmap(image< pixel_rgba > &img) {

  QImage temp( img.getWidth(), img.getHeight(), QImage::Format_RGB32 );
  cerr << img.getWidth() << " " << img.getHeight() << endl;
  // Line-wise copying required, as QImage does 32 bit memory alignment!
  // Direct access to image-memory!
  pixel_rgba *p = img.rawData();
  for( int y=0; y<img.getHeight(); y++ ) {
    copy( p,
          p + img.getWidth(),
          (pixel_rgba *)temp.scanLine( y ) );
    p += img.getWidth();
  };
  
  return QPixmap::fromImage(temp);
}
