#ifndef PICTURE_H
#define PICTURE_H

#include <QtGui/QPixmap>
#include <vector>
#include <mimas/camera.h>
#include <mimas/image_v4linput.h>
#include <mimas/rgba.h>
#include "config.h"

using namespace mimas;
using namespace camera_calibration;
using namespace std;

typedef rgba< unsigned char > pixel_rgba;

class Picture {

 private:
  image< pixel_rgba > img;

 public:
  vector< pixel_f > points;
  pixel_f corns[4];

  // Constructors
  Picture(string device) throw (mimasexception);
  Picture(image< pixel_rgba > &image);
  Picture(image< unsigned char > &image);

  // Convert an image to a QPixmap
  static QPixmap img2pixmap(image< pixel_rgba > &img);

  QPixmap getPixmap(){ return img2pixmap(img); }
  image< pixel_rgba > getImage(){ return img; }

};

#endif
